#include <stdio.h>
#include <bits/stdc++.h>

using namespace std;

int jeLiNula(long long duzina, long long niz[])
{
    long long i;
    for(i = 0; i<duzina; i++) if(niz[i] == 1) return 0;
    return 1;
}


int main()
{
    long long n, q;
    scanf("%ld", &n);
    scanf("%ld", &q);

    long long d[n], p[n], h[q];

    long long i;
    for(i = 0; i<n; i++)
    {
        scanf("%ld%ld", &d[i], &p[i]);

    }
    for(i = 0; i<q; i++)
    {
        scanf("%d", &h[i]);
    }

    if(jeLiNula(n, p))
    {
        for(i = 0; i<q; i++)
        {
            long long zbirTren = 0, c = 0;
            while(zbirTren < h[i] && c<n)
            {
                zbirTren += d[c]; c++;
            }

            if(zbirTren >= h[i]) printf("%d\n", c); else printf("-1\n");
        }

    }

    if(jeLiNula(n, d))
    {
        for(i = 0; i<q; i++)
        {
            long long zbirTren = 0, c = 0;
            while(zbirTren < h[i] && c<n)
            {
                zbirTren += (zbirTren+d[c]); c++;
            }

            if(zbirTren >= h[i]) printf("%d\n", c); else printf("-1\n");
        }

    }

    return 0;
}